<?php
require_once 'ajaxSetup.php';

switch ( $_POST['action'] ) :
	case 'load':
		$listFields = array(
			'city' => 'City',
			'venue' => 'Venue',
			'eventName' => 'Event Name',
			'date' => 'Date',
			'time' => 'Time',
			'shortNotes' => 'Short Notes',
			'tickets' => 'Ticket Link',
			'map' => 'Map Link',
		);
		
		$titleFields = array(
			'city' => 'City',
			'venue' => 'Venue',
			'eventName' => 'Event Name',
			'date' => 'Date',
		);
		
		$defaults = array(
			'archive' => -1,
			'category' => get_option('default_category'),
			'no-upcoming' => 'Sorry, there aren\'t any upcoming gigs right now.  Check back soon!',
			'no-past' => 'There aren\'t any gigs here right now.  Check back soon!',
			'silk-link' => 1,
			'b4b-link' => 1,
			'rss-link' => 1,
			'gigs-table-show' => array_keys($listFields),
			'gig-title-show' => array('city', 'date'),
			'eventName-label' => "Who",
			'short-date-format' => 'm/d/y',
			'long-date-format' => 'l, F j, Y',
		);
		
		unset($defaults['gigs-table-show'][array_search('eventName', $defaults['gigs-table-show'])]);
		
		if ( is_array($options) ) {
			$options = array_merge($defaults, $options);
		} else {
			$options = $defaults;
		}
		
		?>
			<?php if ( !$options || empty($options['parent']) ) : ?>
				<div>You need to select a page to list your calendar.  You may need to go create a <a href="page-new.php">new page</a> first.
			<?php endif; ?>
			<form id="settings-form" method="post">
				<input type="hidden" name="nonce" value="<?php echo $_POST['nonce']; ?>" />
				<input type="hidden" name="action" value="save" />
				<h3>General Options</h3>
				<div><label>
					Select a page to house your calendar: 
					<?php wp_dropdown_pages('show_option_none=Select one...&name=parent&selected=' . $options['parent']); ?>
				</label></div>
				
				<div><label>
					Select a page to house your gigs archive: 
					<?php wp_dropdown_pages('show_option_none=--None--&name=archive&selected=' . $options['archive']); ?>
				</label></div>

				<div><label>
					Select a category that gigs should be created under: 
					<select name="category">
						<?php foreach ( get_categories(array('hide_empty'=>false)) as $cat ) : ?>
							<option value="<?php echo $cat->term_id ?>" <?php if ( isset($options['category']) && $options['category'] == $cat->term_id) echo 'selected="selected"'; ?>><?php echo $cat->name ?></option>
						<?php endforeach; ?>
					</select>
				</label></div>
				
				<div><label>
					Short date format:
					<input type="text" name="short-date-format" value="<?php if ( isset($options['short-date-format']) ) dtcGigs::escapeForInput($options['short-date-format']); ?>" />
				</label> (uses PHP's <a href="http://php.net/date">date()</a> function format)</div>

				<div><label>
					Long date format:
					<input type="text" name="long-date-format" value="<?php if ( isset($options['long-date-format']) ) dtcGigs::escapeForInput($options['long-date-format']); ?>" />
				</label> (uses PHP's <a href="http://php.net/date">date()</a> function format)</div>
				
				<div><label>
					Display this message if there are no upcoming gigs:<br />
					<textarea rows="2" cols="50" name="no-upcoming"><?php echo $options['no-upcoming'] ?></textarea>
				</label></div>
				
				<div><label>
					Display this message if there are no past gigs:<br />
					<textarea rows="2" cols="50" name="no-past"><?php echo $options['no-past'] ?></textarea>
				</label></div>

				<h3>Display Options</h3>
			
				<h4>Gigs page table</h4>
				<div>You can sort the fields by clicking on the names and dragging.</div>
				<ul id="gigs-table">
					<?php if ( isset($options['gigs-table-show']) && is_array($options['gigs-table-show']) ) : ?>
						<?php foreach ( $options['gigs-table-show'] as $field ) : ?>
							<li class="gigs-table-cell">
								<input type="checkbox" name="gigs-table-show[]" value="<?php echo $field ?>" checked="checked" />
								<span class="name"><?php echo $listFields[$field] ?></span>
							</li>
						<?php endforeach; ?>
					<?php endif ?>
					<?php foreach ( $listFields as $key => $value ) : ?>
						<?php if ( !isset($options['gigs-table-show']) || !is_array($options['gigs-table-show']) || !in_array($key, $options['gigs-table-show']) ) : ?>
							<li class="gigs-table-cell">
								<input type="checkbox" name="gigs-table-show[]" value="<?php echo $key ?>" />
								<span class="name"><?php echo $value ?></span>
							</li>
						<?php endif; ?>
					<?php endforeach; ?>
				</ul>
				<div><label>
					Field to use for the link to the gig: 
					<select name="gig-link-field">
						<?php foreach ( $listFields as $key => $value ) : ?>
							<?php if ( !in_array($key, array('tickets', 'map', 'shortNotes')) ) : ?>
								<option value="<?php echo $key ?>" <?php if ( isset($options['gig-link-field']) && $options['gig-link-field'] == $key) echo 'selected="selected"'; ?>><?php echo $value; ?></option>
							<?php endif; ?>
						<?php endforeach; ?>
					</select>
				</label></div>
				
				<!--
				<div><label>
					Do you want to include a link to the RSS feed?
					<select name="rss-link">
						<option value="1" <?php if ( isset($options['rss-link']) && $options['rss-link'] == '1') echo 'selected="selected"'; ?>>Yes</option>
						<option value="0" <?php if ( isset($options['rss-link']) && $options['rss-link'] == '0') echo 'selected="selected"'; ?>>No</option>
					</select>
				</label></div>
				-->

				
				<h4>Single Gig Page</h4>
				
				<div>Select and drag the fields for the gig post title.</div>
				<ul id="gig-title">
					<?php if ( isset($options['gig-title-show']) && is_array($options['gig-title-show']) ) : ?>
						<?php foreach ( $options['gig-title-show'] as $field ) : ?>
							<li class="gig-title-cell">
								<input type="checkbox" name="gig-title-show[]" value="<?php echo $field ?>" checked="checked" />
								<span class="name"><?php echo $titleFields[$field] ?></span>
							</li>
						<?php endforeach; ?>
					<?php endif ?>
					<?php foreach ( $titleFields as $key => $value ) : ?>
						<?php if ( !isset($options['gig-title-show']) || !is_array($options['gig-title-show']) || !in_array($key, $options['gig-title-show']) ) : ?>
							<li class="gig-title-cell">
								<input type="checkbox" name="gig-title-show[]" value="<?php echo $key ?>" />
								<span class="name"><?php echo $value ?></span>
							</li>
						<?php endif; ?>
					<?php endforeach; ?>
				</ul>

				<div><label>
					Label next to the event name:
					<input type="text" name="eventName-label" value="<?php if ( isset($options['eventName-label']) ) dtcGigs::escapeForInput($options['eventName-label']); ?>" />
				</label></div>



				<h3>Credits</h3>
				<div><label>
					Do you want to link back to me for building this plugin?
					<select name="b4b-link">
						<option value="1" <?php if ( isset($options['b4b-link']) && $options['b4b-link'] == '1') echo 'selected="selected"'; ?>>Yes</option>
						<option value="0" <?php if ( isset($options['b4b-link']) && $options['b4b-link'] == '0') echo 'selected="selected"'; ?>>No</option>
					</select>
				</label></div>
				<div style="margin: 0px 1.5em 1em;">
					<b>Note</b>: It's ok to say "no".  I've offered this freely with no expectations.
				</div>
				
				<div><label>
					Do you want to link back to <a target="_blank" href="http://www.famfamfam.com/lab/icons/silk/">Mark James</a> for the Silk icons?
					<select name="silk-link">
						<option value="1" <?php if ( isset($options['silk-link']) && $options['silk-link'] == '1') echo 'selected="selected"'; ?>>Yes</option>
						<option value="0" <?php if ( isset($options['silk-link']) && $options['silk-link'] == '0') echo 'selected="selected"'; ?>>No</option>
					</select>
				</label></div>
				<div style="margin: 0px 1.5em;">
					<b>Note</b>: The Silk Icons that I used in this plugin are licensed under the 
					<a target="_blank" href="http://creativecommons.org/licenses/by/2.5/">Creative Commons</a>.  
					You must link back to him somewhere on your site.  If you link to him on another
					page, giving him credit, or you have replaced the icons, or you do not display
					any of them publicly on your site, you may turn off this link.
				</div>
							
				<br /><br />
				<div><input type="submit" value="Save Options" /></div>
			</form>
			
			<div class="todo">
				<h3>Settings to come</h3>
				<ul>
					
				</ul>		
			</div>
			
			<script type="text/javascript">
				(function($){
					setupEvents = function() {
						jQuery("#settings form").ajaxForm({
							url:pageTarget,
							success:function(){
								if ( jQuery("#gigs-menu li").length == 1 ) {
									window.location.reload();
								} else {
									gigs_page_load("settings");
								}
							}
						});
						
						$("#gigs-table").Sortable({
							accept:"gigs-table-cell",
							handle : "span.name",
							axis:'vertically'
						});
						$("#gig-title").Sortable({
							accept:"gig-title-cell",
							handle : "span.name",
							axis:'vertically'
						});
						
						
					}
				}(jQuery));
				
				setTimeout("setupEvents();");
			</script>
			

		<?php
		break;
	case 'save':
		$args = $_POST;
		unset($args['nonce'], $args['action']);
		if ( empty($args['short-date-format']) ) {
			$args['short-date-format'] = 'm/d/y';
		}
		if ( empty($args['long-date-format']) ) {
			$args['long-date-format'] = 'l, F j, Y';
		}
		
		foreach ( $args as $key => $value ) {
			if ( is_string($value) ) {
				$args[$key] = stripslashes($value);
			}
		}
		
		$options = get_option('gigs-calendar');
		if ( is_array($options) ) {
			$args = array_merge($options, $args);
		}
		
		update_option('gigs-calendar', $args);
		$option = get_option('gigs-calendar');
		break;
endswitch;

