<?php

require_once 'ajaxSetup.php';
$pageTarget = $folder . 'venues.ajax.php';

switch ($_POST['action']) {
	case 'load':
		//$categories = $wpdb->get_results('SELECT * FROM `' . TABLE_CATS . '` ORDER BY `' . $options['categorySortColumn'] .'` ' . $options['categorySortDirection']);
		$v = new venue();
		$v->search('deleted = 0', 'name');
		?>
			<div class="clickable" id="venue-add-trigger">
				<img class="icon" src="<?php echo $folder; ?>images/add.png" /> Add a new venue
			</div>
			<div id="venue-add-form" style="<?php if ( !isset($_GET['new']) ) echo 'display: none;' ?>">
				<form id="new-venue-form" class="new-item" method="post" action="<?php echo $pageTarget; ?>">
					<table>
						<tbody>
							<tr><td><label for="new-name">Name:</label></td><td><input type="text" class="name wide" name="name" id="new-name" /></td></tr>
							<tr><td valign="top"><label for="new-address">Address:</label></td><td><textarea class="address wide" name="address" id="new-address"></textarea></td></tr>
							<tr><td><label for="new-city">City:</label></td><td><input type="text" class="city wide" name="city" id="new-city" /></td></tr>
							<tr><td><label for="new-state">State/Province:</label></td><td><input type="text" class="state wide" name="state" id="new-state" /></td></tr>
							<tr><td><label for="new-country">Country:</label></td><td><input type="text" class="country wide" name="country" id="new-country" /></td></tr>
							<tr><td><label for="new-postalCode">Postal Code:</label></td><td><input type="text" class="postalCode" name="postalCode" id="new-postalCode" /></td></tr>
							<tr><td><label for="new-customMap">Custom location for Google Maps:</label></td><td><input type="text" class="customMap wide" name="customMap" id="new-customMap" /></td></tr>
							<tr><td><label for="new-contact">Primary Contact:</label></td><td><input type="text" class="contact wide" name="contact" id="new-contact" /></td></tr>
							<tr><td><label for="new-phone">Phone:</label></td><td><input type="text" class="phone wide" name="phone" id="new-phone" /></td></tr>
							<tr><td><label for="new-email">Email:</label></td><td><input type="text" class="email wide" name="email" id="new-email" /></td></tr>
							<tr><td><label for="new-link">Homepage:</label></td><td><input type="text" class="link wide" name="link" id="new-link" /></td></tr>
						</tbody>
					</table>
					<div>
						<label for="new-private">Hide information about this venue from the public: <input type="checkbox" value="1" name="private" id="new-private" /></label>
					</div>
					<div>
						Description/Other notes:<br />
						<textarea class="notes" name="notes" rows="7" cols="80"></textarea>
					</div>
					<div>
						<input type="submit" name="" value="Add Venue" />
						<input type="reset" name="" value="Cancel" id="new-venue-reset" />
						<input type="hidden" name="action" value="add" />
						<input type="hidden" name="nonce" value="<?php echo $_POST['nonce']; ?>" />
					</div>
				</form>
			</div>
			
			<table id="venue-list" class="venues widefat">
				<thead>
					<tr>
						<th style="text-align: center;" scope="col">ID</th>
						<th scope="col">Name</th>
						<th scope="col">City</th>
						<th scope="col">Phone</th>
						<th scope="col">Email</th>
						<th style="text-align: center" scope="col">Actions</th>
					</tr>
				</thead>
				<tbody>
					<?php while ( $v->fetch() ) : ?>
						<tr id="venue-<?php echo $v->id; ?>" class="venue-<?php echo $v->id; ?> <?php echo ++$count % 2 ? "alternate" : "";?>">
							<th style="text-align: center;" scope="row"><?php echo $v->id; ?></th>
							<td class="name"><?php echo $v->name; ?></td>
							<td class="city"><?php echo $v->city . (!empty($v->state) ? ', ' . $v->state :  '') ?></td>
							<td class="phone"><?php echo $v->phone ?></td>
							<td class="email"><?php echo !empty($v->email) ? '<a href="mailto:' . $v->email . '">' . $v->email . '</a>' : '' ?></td>
							<td class="actions" style="text-align: center; position: relative;">
								<div style="position: relative">
									<img alt="Edit" title="Edit" class="clickable edit" src="<?php echo $folder; ?>images/page_white_edit.png" />
									<a target="_blank" href="<?php echo $v->getMapLink(); ?>"><img alt="Map" title="Map" class="clickable map" src="<?php echo $folder; ?>images/world.png" /></a>
									<?php if ( !empty($v->link) ) : ?>
										<a target="_blank" href="<?php echo $v->link ?>"><img alt="Homepage" title="Homepage" class="clickable homepage" src="<?php echo $folder ?>images/link.png" /></a>
									<?php endif ?>
									<img alt="Delete" title="Delete" class="clickable delete" src="<?php echo $folder; ?>images/delete.png" />
								</div>
							</td>
						</tr>
						<tr id="venue-panel-<?php echo $v->id; ?>" class="venue-<?php echo $v->id; ?> panel <?php echo $count % 2 ? "alternate" : "";?>">
							<td style="background-color: white"></td>
							<td class="panel" colspan="5"></td>
						</tr>
					<?php endwhile; ?>
				</tbody>
			</table>
				
			<script type="text/javascript">
			
				(function($){
					//init = function() {
					$("#venue-add-trigger").click(function(){
						$("#venue-add-form:hidden").slideDown(300, function(){
							$("#new-name").focus();
						});
					});
					
					$("#new-venue-reset").click(function(){
						$("#venue-add-form").slideUp(300);
					});
					
					$("#new-venue-form").ajaxForm({
						dataType: "json",
						success:function(json){
							venues = $("table#venue-list tbody tr:not(.panel) td.name");
							inserted = false;
							for ( i = 0; i < venues.length; i++ ) {
								if ( json.venue.name.toLowerCase() < venues.eq(i).html().toLowerCase() ) {
									v = venues.eq(i);
									$.post(pageTarget, {
										nonce:nonce,
										action:'getRow',
										id:json.venue.id
									}, function(rsp){
										v.parents("tr").before(rsp);
										resetTableColors("table#venue-list");
										setupEvents();
									});
									inserted = true;
									break;
								}
							}
							if ( !inserted ) {
								$.post(pageTarget, {
									nonce:nonce,
									action:'getRow',
									id:json.venue.id
								}, function(rsp){
									$("table#venue-list tbody").append(rsp);
									resetTableColors("table#venue-list");
									setupEvents();
								});
							}
							$("#new-venue-reset").click();
						}
					});
					
					setupEvents = function() {
						$("img.delete").unbind("click");
						$("img.delete").click(function(){
							id = $(this).parents("tr").attr("id").split("-")[1];
							$.post(pageTarget, {
								nonce:nonce,
								action:'delete',
								id:id
							});
							$(this).parents("tr").next().remove();
							$(this).parents("tr").remove();
							resetTableColors("table#venue-list");
						});
						
						$("img.edit").unbind("click");
						$("img.edit").click(function(){
							row = $(this).parents("tr");
							id = row.attr("id").split("-")[1];
							row.next().children("td.panel").load(pageTarget, {
								nonce:nonce,
								action:"edit",
								id:id
							}, function(){
								row.next().css("display", "table-row");
							});
						});
					}
					
					setupEvents();
				}(jQuery));
				
			
			
			</script>
			
			<div class="todo">
				<h3>Todo</h3>
				<ul>
					<li>embedded mapping (0.2)</li>
					<li>show gig chronology per venue (0.2)</li>
					<li>pagination, search venues (0.2)</li>
					<li>generate list of venues performed at (0.3)</li>
					<li>custom venue data (0.4)</li>
				</ul>
			</div>
		<?php
		break;
	case 'add':
		$v = new venue();
		$args = $_POST;
		unset($args['nonce'],$args['action']);
		foreach ( $args as $key => $value ) {
			$v->$key = $value;
		}
		if ( $v->save() ) {
			echo '{success:true, venue:' . $v->toJSON() . '}';
		} else {
			echo '{success:false}';
		}
		break;
	case 'map':
		//$v = new venue($_GET['id']);
	case 'getRow':
		$v = new venue($_POST['id']);
		?>
			<tr id="venue-<?php echo $v->id; ?>" class="song-<?php echo $v->id; ?>">
				<th style="text-align: center;" scope="row"><?php echo $v->id; ?></th>
				<td class="name"><?php echo $v->name; ?></td>
				<td class="city"><?php echo $v->city . (!empty($v->state) ? ', ' . $v->state :  '') ?></td>
				<td class="phone"><?php echo $v->phone ?></td>
				<td class="email"><?php echo !empty($v->email) ? '<a href="mailto:' . $v->email . '">' . $v->email . '</a>' : '' ?></td>
				<td class="actions" style="text-align: center; position: relative;">
					<div style="position: relative">
						<img alt="Edit" title="Edit" class="clickable edit" src="<?php echo $folder; ?>images/page_white_edit.png" />
						<a target="_blank" href="http://maps.google.com/?q=<?php echo urlencode($v->getAddress(true)); ?>"><img alt="Map" title="Map" class="clickable map" src="<?php echo $folder; ?>images/world.png" /></a>
						<?php if ( !empty($v->link) ) : ?>
							<a target="_blank" href="<?php echo $v->link ?>"><img alt="Homepage" title="Homepage" class="clickable homepage" src="<?php echo $folder ?>images/link.png" /></a>
						<?php endif ?>
						<img alt="Delete" title="Delete" class="clickable delete" src="<?php echo $folder; ?>images/delete.png" />
					</div>
				</td>
			</tr>
			<tr id="venue-panel-<?php echo $v->id; ?>" class="song-<?php echo $v->id; ?> panel <?php echo $count % 2 ? "alternate" : "";?>">
				<td style="background-color: white"></td>
				<td class="panel" colspan="5"></td>
			</tr>
		<?php
		break;
	
	case 'delete':
		$v = new venue($_POST['id']);
		$v->delete();
		break;
		
	case 'edit':
		$v = new venue($_POST['id']);
		?>
			<form id="edit-venue-<?php echo $v->id ?>" class="edit-item venue-<?php echo $v->id ?>" method="post" action="<?php echo $pageTarget; ?>">
				<table>
					<tbody>
						<tr><td><label for="edit-name-<?php echo $v->id ?>">Name:</label></td><td><input type="text" class="name wide" name="name" id="edit-name-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->name) ?>" /></td></tr>
						<tr><td valign="top"><label for="edit-address-<?php echo $v->id ?>">Address:</label></td><td><textarea class="address wide" name="address" id="edit-address-<?php echo $v->id ?>"><?php echo dtcGigs::escapeForInput($v->address) ?></textarea></td></tr>
						<tr><td><label for="edit-city-<?php echo $v->id ?>">City:</label></td><td><input type="text" class="city wide" name="city" id="edit-city-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->city) ?>" /></td></tr>
						<tr><td><label for="edit-state-<?php echo $v->id ?>">State/Province:</label></td><td><input type="text" class="state wide" name="state" id="edit-state-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->state) ?>" /></td></tr>
						<tr><td><label for="edit-country-<?php echo $v->id ?>">Country:</label></td><td><input type="text" class="country wide" name="country" id="edit-country-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->country) ?>" /></td></tr>
						<tr><td><label for="edit-postalCode-<?php echo $v->id ?>">Postal Code:</label></td><td><input type="text" class="postalCode" name="postalCode" id="edit-postalCode-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->postalCode) ?>" /></td></tr>
						<tr><td><label for="edit-customMap-<?php echo $v->id ?>">Custom location for Google Maps:</label></td><td><input type="text" class="customMap wide" name="customMap" id="edit-customMap-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->customMap) ?>" /></td></tr>
						<tr><td><label for="edit-contact-<?php echo $v->id ?>">Primary Contact:</label></td><td><input type="text" class="contact wide" name="contact" id="edit-contact-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->contact) ?>" /></td></tr>
						<tr><td><label for="edit-phone-<?php echo $v->id ?>">Phone:</label></td><td><input type="text" class="phone wide" name="phone" id="edit-phone-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->phone) ?>" /></td></tr>
						<tr><td><label for="edit-email-<?php echo $v->id ?>">Email:</label></td><td><input type="text" class="email wide" name="email" id="edit-email-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->email) ?>" /></td></tr>
						<tr><td><label for="edit-link-<?php echo $v->id ?>">Homepage:</label></td><td><input type="text" class="link wide" name="link" id="edit-link-<?php echo $v->id ?>" value="<?php echo dtcGigs::escapeForInput($v->link) ?>" /></td></tr>
					</tbody>
				</table>
				<div>
					<label for="edit-private-<?php echo $v->id ?>">Hide information about this venue from the public: <input <?php if ( $v->private ) echo 'checked="checked"' ?> type="checkbox" value="1" name="private" id="edit-private-<?php echo $v->id ?>" /></label>
				</div>
				<div>
					Description/Other notes:<br />
					<textarea class="notes" name="notes" rows="7" cols="80"><?php echo dtcGigs::escapeForInput($v->notes) ?></textarea>
				</div>
				<div>
					<input type="submit" name="" value="Save Changes" />
					<input type="reset" name="" value="Cancel" id="edit-venue-reset-<?php echo $v->id ?>" />
					<input type="hidden" name="id" value="<?php echo $v->id ?>" />
					<input type="hidden" name="action" value="save" />
					<input type="hidden" name="nonce" value="<?php echo $_POST['nonce']; ?>" />
				</div>
			</form>
			
			<script type="text/javascript">
				(function($){
					$("#edit-venue-reset-<?php echo $v->id ?>").click(function(){
						$(this).parents("tr.panel").hide();
					});
					
					$("#edit-venue-<?php echo $v->id ?>").ajaxForm({
						dataType: "json",
						success:function(json){
							$("#venue-panel-" + json.venue.id).hide();
							row = $("#venue-" + json.venue.id);
							row.children("td.name").html(json.venue.name);
							row.children("td.phone").html(json.venue.phone);
							
							city = json.venue.city;
							if ( json.venue.state != "" ) {
								if ( city != "" ) {
									city += ", ";
								}
								city += json.venue.state;
							}
							row.children("td.city").html(city);
							
							if ( json.venue.email != "" ) {
								row.children("td.email").html("<a href=\"mailto:" + json.venue.email + "\">" + json.venue.email + "</a>");
							}
						}
					});
				}(jQuery));
			</script>
		<?php
		break;
		
	case 'save':
		$v = new venue($_POST['id']);
		$args = $_POST;
		unset($args['nonce'],$args['action'],$args['id']);
		foreach ( $args as $key => $value ) {
			$v->$key = $value;
		}
		if ( $v->save() ) {
			echo '{success:true, venue:' . $v->toJSON() . '}';
		} else {
			echo '{success:false}';
		}
		break;
}


